import numpy as np
import scipy as sp
import scipy.ndimage as spi

import matplotlib
import matplotlib.pyplot as plt
      

#Ich gehe davon aus, dass scipy.ndimage wieder erlaubt ist.


def opFromSrc(opImg):
    bwOp = opImg < 0.8
    bwOp = spi.binary_closing(bwOp, sp.ones((2,2)))
    
    # erzeuge hit bzw. miss Struktur durch erosion/dilation -> Toleranzbereich
    hit = spi.binary_erosion(bwOp, sp.ones((5,5)))
    miss = spi.binary_dilation(bwOp, sp.ones((5,5))) == 0
    
    return (hit, miss)
    
def nonMax(input):
    out = sp.zeros(input.shape)
    
    for m in range(input.shape[0]):
        for n in range(input.shape[1]):
            if ((m + 1 >= input.shape[0] or input[m + 1, n] < input[m,n]) and
                (n + 1 >= input.shape[1] or input[m, n+1] < input[m,n]) and
                (m+1 >= input.shape[0] or n+1 >= input.shape[1] or input[m+1,n+1] < input[m,n])): 
                out[m,n] = input[m,n]
    
    return out
    
def find(bwImg, hit, miss, startAngle, stopAngle, angleStep):
    res = sp.zeros(bwImg.shape)
    angle = startAngle
    
    while (True):
        print angle,
        
        h = spi.rotate(hit, angle)
        m = spi.rotate(miss, angle)
        
        res += spi.binary_hit_or_miss(bwImg, h, m)
        
        print ": ", res.max()
        
        angle += angleStep  
        if (angleStep == 0 or angle >= stopAngle):
            break

    #non-maximum-suppression
    res = nonMax(res)
    
    return sp.where(res > 0)

def showMasks():
    opImg = plt.imread("img/ic_ok.png")
    (hit, miss) = opFromSrc(opImg)
    
    plt.gray()
    plt.subplot(3,2,1)
    plt.imshow(hit)
    plt.title("Hit-OK")
    
    plt.subplot(3,2,2)
    plt.imshow(miss)
    plt.title("Miss-OK")
    
    opImg = plt.imread("img/ic_broken_1.png")
    (hit, miss) = opFromSrc(opImg)
    
    plt.gray()
    plt.subplot(3,2,3)
    plt.imshow(hit)
    plt.title("Hit-Broken_1")
    
    plt.subplot(3,2,4)
    plt.imshow(miss)
    plt.title("Miss-Broken_1")
    
    opImg = plt.imread("img/ic_broken_2.png")
    (hit, miss) = opFromSrc(opImg)
    
    plt.gray()
    plt.subplot(3,2,5)
    plt.imshow(hit)
    plt.title("Hit-Broken_2")
    
    plt.subplot(3,2,6)
    plt.imshow(miss)
    plt.title("Miss-Broken_2")
    
    plt.show()


showMasks()
    
img = plt.imread("img/ics.png")[:,:,0]


bwImg = (img < img.mean())
bwImg = spi.binary_closing(bwImg, sp.ones((2,2)))

plt.gray()
plt.imshow(img)

opImg = plt.imread("img/ic_ok.png")
(hit, miss) = opFromSrc(opImg)

coords = find(bwImg, hit, miss, 0, 360, 2)
plt.scatter(coords[1], coords[0], color='blue')


opImg = plt.imread("img/ic_broken_1.png")
(hit, miss) = opFromSrc(opImg)

coords = find(bwImg, hit, miss, 248, 360, 2)
plt.scatter(coords[1], coords[0], color='red')


opImg = plt.imread("img/ic_broken_2.png")
(hit, miss) = opFromSrc(opImg)

coords = find(bwImg, hit, miss, 18, 24, 2)
plt.scatter(coords[1], coords[0], color='yellow')

plt.show()